edu.wpi.first.wpilibj.networktables

## Class NetworkTable

- java.lang.Object
- - edu.wpi.first.wpilibj.networktables.NetworkTable

- All Implemented Interfaces:
    IRemote, ITable

  Deprecated.
  Use `NetworkTable` instead.

      @Deprecated
      public class NetworkTable
      extends java.lang.Object
      implements ITable, IRemote

  A network table that knows its subtable path.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `DEFAULT_PORT` Deprecated. The default port that network tables operates on
    `static char` | `PATH_SEPARATOR` Deprecated. The path separator for sub-tables and keys
    `static int` | `PERSISTENT` Deprecated. The persistent flag value.

    - ### Fields inherited from interface edu.wpi.first.wpilibj.tables.ITable

      `NOTIFY_DELETE, NOTIFY_FLAGS, NOTIFY_IMMEDIATE, NOTIFY_LOCAL, NOTIFY_NEW, NOTIFY_UPDATE`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addConnectionListener(IRemoteConnectionListener listener, boolean immediateNotify)` Deprecated. Use `NetworkTableInstance.addConnectionListener(Consumer, boolean)` instead.
    `static void` | `addGlobalConnectionListener(IRemoteConnectionListener listener, boolean immediateNotify)` Deprecated. Use `NetworkTableInstance.addConnectionListener(Consumer, boolean)` instead.
    `void` | `addSubTableListener(ITableListener listener)` Deprecated. Use `NetworkTable.addSubTableListener(TableListener, boolean)` instead.
    `void` | `addSubTableListener(ITableListener listener, boolean localNotify)` Deprecated. Use `NetworkTable.addSubTableListener(TableListener, boolean)` instead.
    `void` | `addTableListener(ITableListener listener)` Deprecated. Use `NetworkTable.addEntryListener(TableEntryListener, int)` instead (with flags value of NOTIFY_NEW | NOTIFY_UPDATE).
    `void` | `addTableListener(ITableListener listener, boolean immediateNotify)` Deprecated. Use `NetworkTable.addEntryListener(TableEntryListener, int)` instead (with flags value of NOTIFY_NEW | NOTIFY_UPDATE | NOTIFY_IMMEDIATE).
    `void` | `addTableListener(java.lang.String key, ITableListener listener, boolean immediateNotify)` Deprecated. Use `NetworkTable.addEntryListener(String, TableEntryListener, int)` or `NetworkTableEntry.addListener(Consumer, int)` instead.
    `void` | `addTableListenerEx(ITableListener listener, int flags)` Deprecated. Use `NetworkTable.addEntryListener(TableEntryListener, int)` instead.
    `void` | `addTableListenerEx(java.lang.String key, ITableListener listener, int flags)` Deprecated. Use `NetworkTable.addEntryListener(String, TableEntryListener, int)` or `NetworkTableEntry.addListener(Consumer, int)` instead.
    `void` | `clearFlags(java.lang.String key, int flags)` Deprecated. Clears flags on the specified key in this table.
    `void` | `clearPersistent(java.lang.String key)` Deprecated. Stop making a key's value persistent through program restarts.
    `static ConnectionInfo[]` | `connections()` Deprecated. Use `NetworkTableInstance.getConnections()` instead.
    `boolean` | `containsKey(java.lang.String key)` Deprecated. Checks the table and tells if it contains the specified key
    `boolean` | `containsSubTable(java.lang.String key)` Deprecated.
    `void` | `delete(java.lang.String key)` Deprecated. Deletes the specified key in this table.
    `boolean` | `equals(java.lang.Object o)` Deprecated.
    `static void` | `flush()` Deprecated. Use `NetworkTableInstance.flush()` instead.
    `static java.lang.Boolean[]` | `fromNative(boolean[] arr)` Deprecated.
    `static java.lang.Double[]` | `fromNative(double[] arr)` Deprecated.
    `boolean` | `getBoolean(java.lang.String key, boolean defaultValue)` Deprecated. Returns the boolean the key maps to.
    `boolean[]` | `getBooleanArray(java.lang.String key, boolean[] defaultValue)` Deprecated. Returns the boolean array the key maps to.
    `java.lang.Boolean[]` | `getBooleanArray(java.lang.String key, java.lang.Boolean[] defaultValue)` Deprecated. Returns the boolean array the key maps to.
    `double` | `getDouble(java.lang.String key, double defaultValue)` Deprecated. Use `getNumber(String, double)` instead.
    `int` | `getFlags(java.lang.String key)` Deprecated. Returns the flags for the specified key.
    `java.util.Set<java.lang.String>` | `getKeys()` Deprecated. Gets all keys in the table (not including sub-tables).
    `java.util.Set<java.lang.String>` | `getKeys(int types)` Deprecated. Gets all keys in the table (not including sub-tables).
    `double` | `getNumber(java.lang.String key, double defaultValue)` Deprecated. Returns the number the key maps to.
    `double[]` | `getNumberArray(java.lang.String key, double[] defaultValue)` Deprecated. Returns the number array the key maps to.
    `java.lang.Double[]` | `getNumberArray(java.lang.String key, java.lang.Double[] defaultValue)` Deprecated. Returns the number array the key maps to.
    `java.lang.String` | `getPath()` Deprecated. Gets the full path of this table.
    `byte[]` | `getRaw(java.lang.String key, byte[] defaultValue)` Deprecated. Returns the raw value (byte array) the key maps to.
    `java.lang.String` | `getString(java.lang.String key, java.lang.String defaultValue)` Deprecated. Returns the string the key maps to.
    `java.lang.String[]` | `getStringArray(java.lang.String key, java.lang.String[] defaultValue)` Deprecated. Returns the string array the key maps to.
    `ITable` | `getSubTable(java.lang.String key)` Deprecated. Returns the table at the specified key.
    `java.util.Set<java.lang.String>` | `getSubTables()` Deprecated. Gets the names of all subtables in the table.
    `static NetworkTable` | `getTable(java.lang.String key)` Deprecated. Use `NetworkTableInstance.getTable(String)` instead.
    `NetworkTableValue` | `getValue(java.lang.String key)` Deprecated. Gets the value associated with a key as a NetworkTableValue object.
    `java.lang.Object` | `getValue(java.lang.String key, java.lang.Object defaultValue)` Deprecated. Use `NetworkTableEntry.getValue()` instead, e.g. `NetworkTable.getEntry(key).getValue();`
    `static void` | `globalDeleteAll()` Deprecated. Use `NetworkTableInstance.deleteAllEntries()` instead.
    `int` | `hashCode()` Deprecated.
    `static void` | `initialize()` Deprecated. Use `NetworkTableInstance.startServer()` or `NetworkTableInstance.startClient()` instead.
    `boolean` | `isConnected()` Deprecated. Use `NetworkTableInstance.isConnected()` instead.
    `boolean` | `isPersistent(java.lang.String key)` Deprecated. Returns whether the value is persistent through program restarts.
    `boolean` | `isServer()` Deprecated. Use `NetworkTableInstance.getNetworkMode()` instead.
    `static java.lang.String[]` | `loadPersistent(java.lang.String filename)` Deprecated. Use `NetworkTableInstance.loadPersistent(String)` instead.
    `boolean` | `putBoolean(java.lang.String key, boolean value)` Deprecated. Put a boolean in the table
    `boolean` | `putBooleanArray(java.lang.String key, boolean[] value)` Deprecated. Put a boolean array in the table
    `boolean` | `putBooleanArray(java.lang.String key, java.lang.Boolean[] value)` Deprecated. Put a boolean array in the table
    `boolean` | `putDouble(java.lang.String key, double value)` Deprecated. Use `putNumber(String, double)` instead.
    `boolean` | `putNumber(java.lang.String key, double value)` Deprecated. Put a number in the table
    `boolean` | `putNumberArray(java.lang.String key, double[] value)` Deprecated. Put a number array in the table
    `boolean` | `putNumberArray(java.lang.String key, java.lang.Double[] value)` Deprecated. Put a number array in the table
    `boolean` | `putRaw(java.lang.String key, byte[] value)` Deprecated. Put a raw value (byte array) in the table
    `boolean` | `putRaw(java.lang.String key, java.nio.ByteBuffer value, int len)` Deprecated. Put a raw value (bytes from a byte buffer) in the table
    `boolean` | `putString(java.lang.String key, java.lang.String value)` Deprecated. Put a string in the table
    `boolean` | `putStringArray(java.lang.String key, java.lang.String[] value)` Deprecated. Put a string array in the table
    `boolean` | `putValue(java.lang.String key, NetworkTableValue value)` Deprecated. Put a value in the table
    `boolean` | `putValue(java.lang.String key, java.lang.Object value)` Deprecated. Use `NetworkTableEntry.setValue(NetworkTableValue)` instead, e.g. `NetworkTable.getEntry(key).setValue(NetworkTableEntry.makeBoolean(false));`
    `void` | `removeConnectionListener(IRemoteConnectionListener listener)` Deprecated. Use `NetworkTableInstance.removeConnectionListener(int)` instead.
    `static void` | `removeGlobalConnectionListener(IRemoteConnectionListener listener)` Deprecated. Use `NetworkTableInstance.removeConnectionListener(int)` instead.
    `void` | `removeTableListener(ITableListener listener)` Deprecated. Use `NetworkTable.removeTableListener(int)` instead.
    `static void` | `savePersistent(java.lang.String filename)` Deprecated. Use `NetworkTableInstance.savePersistent(String)` instead.
    `static void` | `setClientMode()` Deprecated. Use `NetworkTableInstance.startClient()` instead.
    `boolean` | `setDefaultBoolean(java.lang.String key, boolean defaultValue)` Deprecated. Gets the current value in the table, setting it if it does not exist.
    `boolean` | `setDefaultBooleanArray(java.lang.String key, boolean[] defaultValue)` Deprecated. Gets the current value in the table, setting it if it does not exist.
    `boolean` | `setDefaultBooleanArray(java.lang.String key, java.lang.Boolean[] defaultValue)` Deprecated. Gets the current value in the table, setting it if it does not exist.
    `boolean` | `setDefaultNumber(java.lang.String key, double defaultValue)` Deprecated. Gets the current value in the table, setting it if it does not exist.
    `boolean` | `setDefaultNumberArray(java.lang.String key, double[] defaultValue)` Deprecated. Gets the current value in the table, setting it if it does not exist.
    `boolean` | `setDefaultNumberArray(java.lang.String key, java.lang.Double[] defaultValue)` Deprecated. Gets the current value in the table, setting it if it does not exist.
    `boolean` | `setDefaultRaw(java.lang.String key, byte[] defaultValue)` Deprecated. Gets the current value in the table, setting it if it does not exist.
    `boolean` | `setDefaultString(java.lang.String key, java.lang.String defaultValue)` Deprecated. Gets the current value in the table, setting it if it does not exist.
    `boolean` | `setDefaultStringArray(java.lang.String key, java.lang.String[] defaultValue)` Deprecated. Gets the current value in the table, setting it if it does not exist.
    `boolean` | `setDefaultValue(java.lang.String key, NetworkTableValue defaultValue)` Deprecated. Sets the current value in the table if it does not exist.
    `static void` | `setDSClientEnabled(boolean enabled)` Deprecated. Use `NetworkTableInstance.startDSClient()` and `NetworkTableInstance.stopDSClient()` instead.
    `void` | `setFlags(java.lang.String key, int flags)` Deprecated. Sets flags on the specified key in this table.
    `static void` | `setIPAddress(java.lang.String address)` Deprecated. Use `NetworkTableInstance.setServer(String)` or `NetworkTableInstance.startClient(String)` instead.
    `static void` | `setIPAddress(java.lang.String[] addresses)` Deprecated. Use `NetworkTableInstance.setServer(String[])` or `NetworkTableInstance.startClient(String[])` instead.
    `static void` | `setNetworkIdentity(java.lang.String name)` Deprecated. Use `NetworkTableInstance.setNetworkIdentity(String)` instead.
    `void` | `setPersistent(java.lang.String key)` Deprecated. Makes a key's value persistent through program restarts.
    `static void` | `setPersistentFilename(java.lang.String filename)` Deprecated. Use the appropriate parameter to `NetworkTableInstance.startServer()` instead.
    `static void` | `setPort(int aport)` Deprecated. Use the appropriate parameters to `NetworkTableInstance.setServer(String, int)`, `NetworkTableInstance.startClient(String, int)`, `NetworkTableInstance.startServer(String, String, int)`, and `NetworkTableInstance.startDSClient(int)` instead.
    `static void` | `setServerMode()` Deprecated. Use `NetworkTableInstance.startServer()` instead.
    `static void` | `setTeam(int team)` Deprecated. Use `NetworkTableInstance.setServerTeam(int)` or `NetworkTableInstance.startClientTeam(int)` instead.
    `static void` | `setUpdateRate(double interval)` Deprecated. Use `NetworkTableInstance.setUpdateRate(double)` instead.
    `static void` | `shutdown()` Deprecated. Use `NetworkTableInstance.stopServer()` or `NetworkTableInstance.stopClient()` instead.
    `static boolean[]` | `toNative(java.lang.Boolean[] arr)` Deprecated.
    `static double[]` | `toNative(java.lang.Number[] arr)` Deprecated.
    `java.lang.String` | `toString()` Deprecated.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### PATH_SEPARATOR

          public static final char PATH_SEPARATOR

      Deprecated.
      The path separator for sub-tables and keys
      See Also:
        Constant Field Values

    - #### DEFAULT_PORT

          public static final int DEFAULT_PORT

      Deprecated.
      The default port that network tables operates on
      See Also:
        Constant Field Values

    - #### PERSISTENT

          public static final int PERSISTENT

      Deprecated.
      The persistent flag value.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### initialize

          @Deprecated
          public static void initialize()

      Deprecated. Use `NetworkTableInstance.startServer()` or `NetworkTableInstance.startClient()` instead.
      initializes network tables

    - #### shutdown

          @Deprecated
          public static void shutdown()

      Deprecated. Use `NetworkTableInstance.stopServer()` or `NetworkTableInstance.stopClient()` instead.
      shuts down network tables

    - #### setServerMode

          @Deprecated
          public static void setServerMode()

      Deprecated. Use `NetworkTableInstance.startServer()` instead.
      set that network tables should be a server This must be called before initialize or getTable

    - #### setClientMode

          @Deprecated
          public static void setClientMode()

      Deprecated. Use `NetworkTableInstance.startClient()` instead.
      set that network tables should be a client This must be called before initialize or getTable

    - #### setTeam

          @Deprecated
          public static void setTeam(int team)

      Deprecated. Use `NetworkTableInstance.setServerTeam(int)` or `NetworkTableInstance.startClientTeam(int)` instead.
      set the team the robot is configured for (this will set the mdns address that network tables will connect to in client mode) This must be called before initialize or getTable
      Parameters:
        `team` - the team number

    - #### setIPAddress

          @Deprecated
          public static void setIPAddress(java.lang.String address)

      Deprecated. Use `NetworkTableInstance.setServer(String)` or `NetworkTableInstance.startClient(String)` instead.
      Parameters:
        `address` - the address that network tables will connect to in client mode

    - #### setIPAddress

          @Deprecated
          public static void setIPAddress(java.lang.String[] addresses)

      Deprecated. Use `NetworkTableInstance.setServer(String[])` or `NetworkTableInstance.startClient(String[])` instead.
      Parameters:
        `addresses` - the adresses that network tables will connect to in client mode (in round robin order)

    - #### setPort

          @Deprecated
          public static void setPort(int aport)

      Deprecated. Use the appropriate parameters to `NetworkTableInstance.setServer(String, int)`, `NetworkTableInstance.startClient(String, int)`, `NetworkTableInstance.startServer(String, String, int)`, and `NetworkTableInstance.startDSClient(int)` instead.
      Set the port number that network tables will connect to in client mode or listen to in server mode.
      Parameters:
        `aport` - the port number

    - #### setDSClientEnabled

          @Deprecated
          public static void setDSClientEnabled(boolean enabled)

      Deprecated. Use `NetworkTableInstance.startDSClient()` and `NetworkTableInstance.stopDSClient()` instead.
      Enable requesting the server address from the Driver Station.
      Parameters:
        `enabled` - whether to enable the connection to the local DS

    - #### setPersistentFilename

          @Deprecated
          public static void setPersistentFilename(java.lang.String filename)

      Deprecated. Use the appropriate parameter to `NetworkTableInstance.startServer()` instead.
      Sets the persistent filename.
      Parameters:
        `filename` - the filename that the network tables server uses for automatic loading and saving of persistent values

    - #### setNetworkIdentity

          @Deprecated
          public static void setNetworkIdentity(java.lang.String name)

      Deprecated. Use `NetworkTableInstance.setNetworkIdentity(String)` instead.
      Sets the network identity. This is provided in the connection info on the remote end.
      Parameters:
        `name` - identity

    - #### toNative

          public static boolean[] toNative(java.lang.Boolean[] arr)

      Deprecated.

    - #### toNative

          public static double[] toNative(java.lang.Number[] arr)

      Deprecated.

    - #### fromNative

          public static java.lang.Boolean[] fromNative(boolean[] arr)

      Deprecated.

    - #### fromNative

          public static java.lang.Double[] fromNative(double[] arr)

      Deprecated.

    - #### getTable

          @Deprecated
          public static NetworkTable getTable(java.lang.String key)

      Deprecated. Use `NetworkTableInstance.getTable(String)` instead.
      Gets the table with the specified key. If the table does not exist, a new table will be created.
      This will automatically initialize network tables if it has not been already
      Parameters:
        `key` - the key name
      Returns:
        the network table requested

    - #### toString

          public java.lang.String toString()

      Deprecated.
      Overrides:
        `toString` in class `java.lang.Object`

    - #### connections

          @Deprecated
          public static ConnectionInfo[] connections()

      Deprecated. Use `NetworkTableInstance.getConnections()` instead.
      Gets the current network connections.
      Returns:
        An array of connection information.

    - #### isConnected

          @Deprecated
          public boolean isConnected()

      Deprecated. Use `NetworkTableInstance.isConnected()` instead.
      Determine whether or not a network connection is active.
      Specified by:
        `isConnected` in interface `IRemote`
      Returns:
        True if connected, false if not connected.

    - #### isServer

          @Deprecated
          public boolean isServer()

      Deprecated. Use `NetworkTableInstance.getNetworkMode()` instead.
      Determine whether NetworkTables is operating as a server or as a client.
      Specified by:
        `isServer` in interface `IRemote`
      Returns:
        True if operating as a server, false otherwise.

    - #### addGlobalConnectionListener

          @Deprecated
          public static void addGlobalConnectionListener(IRemoteConnectionListener listener,
                                                                     boolean immediateNotify)

      Deprecated. Use `NetworkTableInstance.addConnectionListener(Consumer, boolean)` instead.
      Add a connection listener.
      Parameters:
        `listener` - connection listener
        `immediateNotify` - call listener immediately for all existing connections

    - #### removeGlobalConnectionListener

          @Deprecated
          public static void removeGlobalConnectionListener(IRemoteConnectionListener listener)

      Deprecated. Use `NetworkTableInstance.removeConnectionListener(int)` instead.
      Remove a connection listener.
      Parameters:
        `listener` - connection listener

    - #### addConnectionListener

          @Deprecated
          public void addConnectionListener(IRemoteConnectionListener listener,
                                                        boolean immediateNotify)

      Deprecated. Use `NetworkTableInstance.addConnectionListener(Consumer, boolean)` instead.
      Add a connection listener.
      Specified by:
        `addConnectionListener` in interface `IRemote`
      Parameters:
        `listener` - connection listener
        `immediateNotify` - call listener immediately for all existing connections

    - #### removeConnectionListener

          @Deprecated
          public void removeConnectionListener(IRemoteConnectionListener listener)

      Deprecated. Use `NetworkTableInstance.removeConnectionListener(int)` instead.
      Remove a connection listener.
      Specified by:
        `removeConnectionListener` in interface `IRemote`
      Parameters:
        `listener` - connection listener

    - #### addTableListener

          @Deprecated
          public void addTableListener(ITableListener listener)

      Deprecated. Use `NetworkTable.addEntryListener(TableEntryListener, int)` instead (with flags value of NOTIFY_NEW | NOTIFY_UPDATE).
      Add a listener for changes to the table
      Specified by:
        `addTableListener` in interface `ITable`
      Parameters:
        `listener` - the listener to add

    - #### addTableListener

          @Deprecated
          public void addTableListener(ITableListener listener,
                                                   boolean immediateNotify)

      Deprecated. Use `NetworkTable.addEntryListener(TableEntryListener, int)` instead (with flags value of NOTIFY_NEW | NOTIFY_UPDATE | NOTIFY_IMMEDIATE).
      Add a listener for changes to the table
      Specified by:
        `addTableListener` in interface `ITable`
      Parameters:
        `listener` - the listener to add
        `immediateNotify` - if true then this listener will be notified of all current entries (marked as new)

    - #### addTableListenerEx

          @Deprecated
          public void addTableListenerEx(ITableListener listener,
                                                     int flags)

      Deprecated. Use `NetworkTable.addEntryListener(TableEntryListener, int)` instead.
      Add a listener for changes to the table
      Specified by:
        `addTableListenerEx` in interface `ITable`
      Parameters:
        `listener` - the listener to add
        `flags` - bitmask specifying desired notifications

    - #### addTableListener

          @Deprecated
          public void addTableListener(java.lang.String key,
                                                   ITableListener listener,
                                                   boolean immediateNotify)

      Deprecated. Use `NetworkTable.addEntryListener(String, TableEntryListener, int)` or `NetworkTableEntry.addListener(Consumer, int)` instead.
      Add a listener for changes to a specific key the table
      Specified by:
        `addTableListener` in interface `ITable`
      Parameters:
        `key` - the key to listen for
        `listener` - the listener to add
        `immediateNotify` - if true then this listener will be notified of all current entries (marked as new)

    - #### addTableListenerEx

          @Deprecated
          public void addTableListenerEx(java.lang.String key,
                                                     ITableListener listener,
                                                     int flags)

      Deprecated. Use `NetworkTable.addEntryListener(String, TableEntryListener, int)` or `NetworkTableEntry.addListener(Consumer, int)` instead.
      Add a listener for changes to a specific key the table
      Specified by:
        `addTableListenerEx` in interface `ITable`
      Parameters:
        `key` - the key to listen for
        `listener` - the listener to add
        `flags` - bitmask specifying desired notifications

    - #### addSubTableListener

          @Deprecated
          public void addSubTableListener(ITableListener listener)

      Deprecated. Use `NetworkTable.addSubTableListener(TableListener, boolean)` instead.
      This will immediately notify the listener of all current sub tables
      Specified by:
        `addSubTableListener` in interface `ITable`
      Parameters:
        `listener` - the listener to notify

    - #### addSubTableListener

          @Deprecated
          public void addSubTableListener(ITableListener listener,
                                                      boolean localNotify)

      Deprecated. Use `NetworkTable.addSubTableListener(TableListener, boolean)` instead.
      This will immediately notify the listener of all current sub tables
      Specified by:
        `addSubTableListener` in interface `ITable`
      Parameters:
        `listener` - the listener to notify
        `localNotify` - if true then this listener will be notified of all local changes in addition to all remote changes

    - #### removeTableListener

          @Deprecated
          public void removeTableListener(ITableListener listener)

      Deprecated. Use `NetworkTable.removeTableListener(int)` instead.
      Remove a listener from receiving table events
      Specified by:
        `removeTableListener` in interface `ITable`
      Parameters:
        `listener` - the listener to be removed

    - #### getSubTable

          public ITable getSubTable(java.lang.String key)

      Deprecated.
      Returns the table at the specified key. If there is no table at the specified key, it will create a new table
      Specified by:
        `getSubTable` in interface `ITable`
      Parameters:
        `key` - the name of the table relative to this one
      Returns:
        a sub table relative to this one

    - #### containsKey

          public boolean containsKey(java.lang.String key)

      Deprecated.
      Checks the table and tells if it contains the specified key
      Specified by:
        `containsKey` in interface `ITable`
      Parameters:
        `key` - the key to search for
      Returns:
        true if the table as a value assigned to the given key

    - #### containsSubTable

          public boolean containsSubTable(java.lang.String key)

      Deprecated.
      Specified by:
        `containsSubTable` in interface `ITable`
      Parameters:
        `key` - the key to search for
      Returns:
        true if there is a subtable with the key which contains at least one key/subtable of its own

    - #### getKeys

          public java.util.Set<java.lang.String> getKeys(int types)

      Deprecated.
      Description copied from interface: `ITable`
      Gets all keys in the table (not including sub-tables).
      Specified by:
        `getKeys` in interface `ITable`
      Parameters:
        `types` - bitmask of types; 0 is treated as a "don't care".
      Returns:
        keys currently in the table

    - #### getKeys

          public java.util.Set<java.lang.String> getKeys()

      Deprecated.
      Gets all keys in the table (not including sub-tables).
      Specified by:
        `getKeys` in interface `ITable`
      Returns:
        keys currently in the table

    - #### getSubTables

          public java.util.Set<java.lang.String> getSubTables()

      Deprecated.
      Gets the names of all subtables in the table.
      Specified by:
        `getSubTables` in interface `ITable`
      Returns:
        subtables currently in the table

    - #### putNumber

          public boolean putNumber(java.lang.String key,
                                   double value)

      Deprecated.
      Put a number in the table
      Specified by:
        `putNumber` in interface `ITable`
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### setDefaultNumber

          public boolean setDefaultNumber(java.lang.String key,
                                          double defaultValue)

      Deprecated.
      Gets the current value in the table, setting it if it does not exist.
      Specified by:
        `setDefaultNumber` in interface `ITable`
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### getNumber

          public double getNumber(java.lang.String key,
                                  double defaultValue)

      Deprecated.
      Returns the number the key maps to. If the key does not exist or is of different type, it will return the default value.
      Specified by:
        `getNumber` in interface `ITable`
      Parameters:
        `key` - the key to look up
        `defaultValue` - the value to be returned if no value is found
      Returns:
        the value associated with the given key or the given default value if there is no value associated with the key

    - #### putString

          public boolean putString(java.lang.String key,
                                   java.lang.String value)

      Deprecated.
      Put a string in the table
      Specified by:
        `putString` in interface `ITable`
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### setDefaultString

          public boolean setDefaultString(java.lang.String key,
                                          java.lang.String defaultValue)

      Deprecated.
      Gets the current value in the table, setting it if it does not exist.
      Specified by:
        `setDefaultString` in interface `ITable`
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### getString

          public java.lang.String getString(java.lang.String key,
                                            java.lang.String defaultValue)

      Deprecated.
      Returns the string the key maps to. If the key does not exist or is of different type, it will return the default value.
      Specified by:
        `getString` in interface `ITable`
      Parameters:
        `key` - the key to look up
        `defaultValue` - the value to be returned if no value is found
      Returns:
        the value associated with the given key or the given default value if there is no value associated with the key

    - #### putBoolean

          public boolean putBoolean(java.lang.String key,
                                    boolean value)

      Deprecated.
      Put a boolean in the table
      Specified by:
        `putBoolean` in interface `ITable`
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### setDefaultBoolean

          public boolean setDefaultBoolean(java.lang.String key,
                                           boolean defaultValue)

      Deprecated.
      Gets the current value in the table, setting it if it does not exist.
      Specified by:
        `setDefaultBoolean` in interface `ITable`
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### getBoolean

          public boolean getBoolean(java.lang.String key,
                                    boolean defaultValue)

      Deprecated.
      Returns the boolean the key maps to. If the key does not exist or is of different type, it will return the default value.
      Specified by:
        `getBoolean` in interface `ITable`
      Parameters:
        `key` - the key to look up
        `defaultValue` - the value to be returned if no value is found
      Returns:
        the value associated with the given key or the given default value if there is no value associated with the key

    - #### putBooleanArray

          public boolean putBooleanArray(java.lang.String key,
                                         boolean[] value)

      Deprecated.
      Put a boolean array in the table
      Specified by:
        `putBooleanArray` in interface `ITable`
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### putBooleanArray

          public boolean putBooleanArray(java.lang.String key,
                                         java.lang.Boolean[] value)

      Deprecated.
      Put a boolean array in the table
      Specified by:
        `putBooleanArray` in interface `ITable`
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### setDefaultBooleanArray

          public boolean setDefaultBooleanArray(java.lang.String key,
                                                boolean[] defaultValue)

      Deprecated.
      Gets the current value in the table, setting it if it does not exist.
      Specified by:
        `setDefaultBooleanArray` in interface `ITable`
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### setDefaultBooleanArray

          public boolean setDefaultBooleanArray(java.lang.String key,
                                                java.lang.Boolean[] defaultValue)

      Deprecated.
      Gets the current value in the table, setting it if it does not exist.
      Specified by:
        `setDefaultBooleanArray` in interface `ITable`
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### getBooleanArray

          public boolean[] getBooleanArray(java.lang.String key,
                                           boolean[] defaultValue)

      Deprecated.
      Returns the boolean array the key maps to. If the key does not exist or is of different type, it will return the default value.
      Specified by:
        `getBooleanArray` in interface `ITable`
      Parameters:
        `key` - the key to look up
        `defaultValue` - the value to be returned if no value is found
      Returns:
        the value associated with the given key or the given default value if there is no value associated with the key

    - #### getBooleanArray

          public java.lang.Boolean[] getBooleanArray(java.lang.String key,
                                                     java.lang.Boolean[] defaultValue)

      Deprecated.
      Returns the boolean array the key maps to. If the key does not exist or is of different type, it will return the default value.
      Specified by:
        `getBooleanArray` in interface `ITable`
      Parameters:
        `key` - the key to look up
        `defaultValue` - the value to be returned if no value is found
      Returns:
        the value associated with the given key or the given default value if there is no value associated with the key

    - #### putNumberArray

          public boolean putNumberArray(java.lang.String key,
                                        double[] value)

      Deprecated.
      Put a number array in the table
      Specified by:
        `putNumberArray` in interface `ITable`
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### putNumberArray

          public boolean putNumberArray(java.lang.String key,
                                        java.lang.Double[] value)

      Deprecated.
      Put a number array in the table
      Specified by:
        `putNumberArray` in interface `ITable`
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### setDefaultNumberArray

          public boolean setDefaultNumberArray(java.lang.String key,
                                               double[] defaultValue)

      Deprecated.
      Gets the current value in the table, setting it if it does not exist.
      Specified by:
        `setDefaultNumberArray` in interface `ITable`
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### setDefaultNumberArray

          public boolean setDefaultNumberArray(java.lang.String key,
                                               java.lang.Double[] defaultValue)

      Deprecated.
      Gets the current value in the table, setting it if it does not exist.
      Specified by:
        `setDefaultNumberArray` in interface `ITable`
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### getNumberArray

          public double[] getNumberArray(java.lang.String key,
                                         double[] defaultValue)

      Deprecated.
      Returns the number array the key maps to. If the key does not exist or is of different type, it will return the default value.
      Specified by:
        `getNumberArray` in interface `ITable`
      Parameters:
        `key` - the key to look up
        `defaultValue` - the value to be returned if no value is found
      Returns:
        the value associated with the given key or the given default value if there is no value associated with the key

    - #### getNumberArray

          public java.lang.Double[] getNumberArray(java.lang.String key,
                                                   java.lang.Double[] defaultValue)

      Deprecated.
      Returns the number array the key maps to. If the key does not exist or is of different type, it will return the default value.
      Specified by:
        `getNumberArray` in interface `ITable`
      Parameters:
        `key` - the key to look up
        `defaultValue` - the value to be returned if no value is found
      Returns:
        the value associated with the given key or the given default value if there is no value associated with the key

    - #### putStringArray

          public boolean putStringArray(java.lang.String key,
                                        java.lang.String[] value)

      Deprecated.
      Put a string array in the table
      Specified by:
        `putStringArray` in interface `ITable`
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### setDefaultStringArray

          public boolean setDefaultStringArray(java.lang.String key,
                                               java.lang.String[] defaultValue)

      Deprecated.
      Gets the current value in the table, setting it if it does not exist.
      Specified by:
        `setDefaultStringArray` in interface `ITable`
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### getStringArray

          public java.lang.String[] getStringArray(java.lang.String key,
                                                   java.lang.String[] defaultValue)

      Deprecated.
      Returns the string array the key maps to. If the key does not exist or is of different type, it will return the default value.
      Specified by:
        `getStringArray` in interface `ITable`
      Parameters:
        `key` - the key to look up
        `defaultValue` - the value to be returned if no value is found
      Returns:
        the value associated with the given key or the given default value if there is no value associated with the key

    - #### putRaw

          public boolean putRaw(java.lang.String key,
                                byte[] value)

      Deprecated.
      Put a raw value (byte array) in the table
      Specified by:
        `putRaw` in interface `ITable`
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### setDefaultRaw

          public boolean setDefaultRaw(java.lang.String key,
                                       byte[] defaultValue)

      Deprecated.
      Gets the current value in the table, setting it if it does not exist.
      Specified by:
        `setDefaultRaw` in interface `ITable`
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### putRaw

          public boolean putRaw(java.lang.String key,
                                java.nio.ByteBuffer value,
                                int len)

      Deprecated.
      Put a raw value (bytes from a byte buffer) in the table
      Specified by:
        `putRaw` in interface `ITable`
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
        `len` - the length of the value
      Returns:
        False if the table key already exists with a different type

    - #### getRaw

          public byte[] getRaw(java.lang.String key,
                               byte[] defaultValue)

      Deprecated.
      Returns the raw value (byte array) the key maps to. If the key does not exist or is of different type, it will return the default value.
      Specified by:
        `getRaw` in interface `ITable`
      Parameters:
        `key` - the key to look up
        `defaultValue` - the value to be returned if no value is found
      Returns:
        the value associated with the given key or the given default value if there is no value associated with the key

    - #### putValue

          public boolean putValue(java.lang.String key,
                                  NetworkTableValue value)

      Deprecated.
      Put a value in the table
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type

    - #### setDefaultValue

          public boolean setDefaultValue(java.lang.String key,
                                         NetworkTableValue defaultValue)

      Deprecated.
      Sets the current value in the table if it does not exist.
      Parameters:
        `key` - the key
        `defaultValue` - the default value to set if key doens't exist.
      Returns:
        False if the table key exists with a different type

    - #### getValue

          public NetworkTableValue getValue(java.lang.String key)

      Deprecated.
      Gets the value associated with a key as a NetworkTableValue object.
      Parameters:
        `key` - the key of the value to look up
      Returns:
        the value associated with the given key

    - #### putValue

          @Deprecated
          public boolean putValue(java.lang.String key,
                                              java.lang.Object value)
                                       throws java.lang.IllegalArgumentException

      Deprecated. Use `NetworkTableEntry.setValue(NetworkTableValue)` instead, e.g. `NetworkTable.getEntry(key).setValue(NetworkTableEntry.makeBoolean(false));`
      Put a value in the table
      Specified by:
        `putValue` in interface `ITable`
      Parameters:
        `key` - the key to be assigned to
        `value` - the value that will be assigned
      Returns:
        False if the table key already exists with a different type
      Throws:
        `java.lang.IllegalArgumentException` - when the value is not supported by the table

    - #### getValue

          @Deprecated
          public java.lang.Object getValue(java.lang.String key,
                                                       java.lang.Object defaultValue)

      Deprecated. Use `NetworkTableEntry.getValue()` instead, e.g. `NetworkTable.getEntry(key).getValue();`
      Gets the value associated with a key as an object. NOTE: If the value is a double, it will return a Double object, not a primitive. To get the primitive, use `ITable.getDouble(String, double)`.
      Specified by:
        `getValue` in interface `ITable`
      Parameters:
        `key` - the key of the value to look up
        `defaultValue` - the default value if the key is null
      Returns:
        the value associated with the given key

    - #### setPersistent

          public void setPersistent(java.lang.String key)

      Deprecated.
      Makes a key's value persistent through program restarts. The key cannot be null.
      Specified by:
        `setPersistent` in interface `ITable`
      Parameters:
        `key` - the key name

    - #### clearPersistent

          public void clearPersistent(java.lang.String key)

      Deprecated.
      Stop making a key's value persistent through program restarts. The key cannot be null.
      Specified by:
        `clearPersistent` in interface `ITable`
      Parameters:
        `key` - the key name

    - #### isPersistent

          public boolean isPersistent(java.lang.String key)

      Deprecated.
      Returns whether the value is persistent through program restarts. The key cannot be null.
      Specified by:
        `isPersistent` in interface `ITable`
      Parameters:
        `key` - the key name
      Returns:
        True if the value is persistent.

    - #### setFlags

          public void setFlags(java.lang.String key,
                               int flags)

      Deprecated.
      Sets flags on the specified key in this table. The key can not be null.
      Specified by:
        `setFlags` in interface `ITable`
      Parameters:
        `key` - the key name
        `flags` - the flags to set (bitmask)

    - #### clearFlags

          public void clearFlags(java.lang.String key,
                                 int flags)

      Deprecated.
      Clears flags on the specified key in this table. The key can not be null.
      Specified by:
        `clearFlags` in interface `ITable`
      Parameters:
        `key` - the key name
        `flags` - the flags to clear (bitmask)

    - #### getFlags

          public int getFlags(java.lang.String key)

      Deprecated.
      Returns the flags for the specified key.
      Specified by:
        `getFlags` in interface `ITable`
      Parameters:
        `key` - the key name
      Returns:
        the flags, or 0 if the key is not defined

    - #### delete

          public void delete(java.lang.String key)

      Deprecated.
      Deletes the specified key in this table. The key can not be null.
      Specified by:
        `delete` in interface `ITable`
      Parameters:
        `key` - the key name

    - #### globalDeleteAll

          @Deprecated
          public static void globalDeleteAll()

      Deprecated. Use `NetworkTableInstance.deleteAllEntries()` instead.
      Deletes ALL keys in ALL subtables. Use with caution!

    - #### flush

          @Deprecated
          public static void flush()

      Deprecated. Use `NetworkTableInstance.flush()` instead.
      Flushes all updated values immediately to the network. Note: This is rate-limited to protect the network from flooding. This is primarily useful for synchronizing network updates with user code.

    - #### setUpdateRate

          @Deprecated
          public static void setUpdateRate(double interval)

      Deprecated. Use `NetworkTableInstance.setUpdateRate(double)` instead.
      Set the periodic update rate.
      Parameters:
        `interval` - update interval in seconds (range 0.01 to 1.0)

    - #### savePersistent

          @Deprecated
          public static void savePersistent(java.lang.String filename)
                                                 throws PersistentException

      Deprecated. Use `NetworkTableInstance.savePersistent(String)` instead.
      Saves persistent keys to a file. The server does this automatically.
      Parameters:
        `filename` - file name
      Throws:
        `PersistentException` - if error saving file

    - #### loadPersistent

          @Deprecated
          public static java.lang.String[] loadPersistent(java.lang.String filename)
                                                               throws PersistentException

      Deprecated. Use `NetworkTableInstance.loadPersistent(String)` instead.
      Loads persistent keys from a file. The server does this automatically.
      Parameters:
        `filename` - file name
      Returns:
        List of warnings (errors result in an exception instead)
      Throws:
        `PersistentException` - if error reading file

    - #### putDouble

          @Deprecated
          public boolean putDouble(java.lang.String key,
                                               double value)

      Deprecated. Use `putNumber(String, double)` instead.
      Maps the specified key to the specified value in this table. The key can not be null. The value can be retrieved by calling the get method with a key that is equal to the original key.
      Specified by:
        `putDouble` in interface `ITable`
      Parameters:
        `key` - the key
        `value` - the value
      Returns:
        False if the table key already exists with a different type

    - #### getDouble

          @Deprecated
          public double getDouble(java.lang.String key,
                                              double defaultValue)

      Deprecated. Use `getNumber(String, double)` instead.
      Returns the value at the specified key.
      Specified by:
        `getDouble` in interface `ITable`
      Parameters:
        `key` - the key
        `defaultValue` - the value returned if the key is undefined
      Returns:
        the value

    - #### getPath

          public java.lang.String getPath()

      Deprecated.
      Gets the full path of this table. Does not include the trailing "/".
      Specified by:
        `getPath` in interface `ITable`
      Returns:
        The path to this table (e.g. "", "/foo").

    - #### equals

          public boolean equals(java.lang.Object o)

      Deprecated.
      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Deprecated.
      Overrides:
        `hashCode` in class `java.lang.Object`